using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace UnifiedPOS.ToneIndicator.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public interface ToneIndicator
    {
        #region Version 1.1

        //
        // Common Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetOutputIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetAsyncMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetAsyncModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetAsyncMode(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetAsyncMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetAsyncModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetAsyncMode(string ConsumerID, bool AsyncMode);    
        
        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapPitch", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapPitchResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapPitch(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapVolume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapVolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        bool GetCapVolume(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetInterToneWait", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetInterToneWaitResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetInterToneWait(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetInterToneWait", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetInterToneWaitResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetInterToneWait(string ConsumerID, int InterToneWait);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1Duration", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1DurationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone1Duration(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1Duration", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1DurationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone1Duration(string ConsumerID, int Tone1Duration);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1Pitch", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1PitchResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone1Pitch(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1Pitch", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1PitchResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone1Pitch(string ConsumerID, int Tone1Pitch);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1Volume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone1VolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone1Volume(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1Volume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone1VolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone1Volume(string ConsumerID, int Tone1Volume);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2Duration", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2DurationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone2Duration(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2Duration", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2DurationResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone2Duration(string ConsumerID, int Tone2Duration);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2Pitch", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2PitchResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone2Pitch(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2Pitch", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2PitchResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone2Pitch(string ConsumerID, int Tone2Pitch);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2Volume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetTone2VolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetTone2Volume(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2Volume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetTone2VolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetTone2Volume(string ConsumerID, int Tone2Volume);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapMelody", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetCapMelodyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetCapMelody(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetMelodyType", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetMelodyTypeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetMelodyType(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetMelodyType", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetMelodyTypeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetMelodyType(string ConsumerID, int MelodyType);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetMelodyVolume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetMelodyVolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetMelodyVolume(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetMelodyVolume", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetMelodyVolumeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetMelodyVolume(string ConsumerID, int MelodyVolume);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ClearOutputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/Sound", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SoundResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void Sound(string ConsumerID, int NumberOfCycles, int InterSoundWait);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SoundImmediate", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SoundImmediateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SoundImmediate(string ConsumerID);

        #endregion

        #region Version 1.2

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        // 

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        ToneIndicatorEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, ToneIndicatorEventResponse EventResponse);

        #endregion

        #region Version 1.3

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        #endregion
    }

    #region Version 1.1

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }
        [DataMember]
        public int Minor { get; set; }
        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,
        [EnumMember]
        CFV_FIRMWARE_SAME,
        [EnumMember]
        CFV_FIRMWARE_NEWER,
        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,
        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,
        [EnumMember]
        S_IDLE,
        [EnumMember]
        S_BUSY,
        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,
        [EnumMember]
        E_CLAIMED,
        [EnumMember]
        E_NOTCLAIMED,
        [EnumMember]
        E_NOSERVICE,
        [EnumMember]
        E_DISABLED,
        [EnumMember]
        E_ILLEGAL,
        [EnumMember]
        E_NOHARDWARE,
        [EnumMember]
        E_OFFLINE,
        [EnumMember]
        E_NOEXIST,
        [EnumMember]
        E_EXISTS,
        [EnumMember]
        E_FAILURE,
        [EnumMember]
        E_TIMEOUT,
        [EnumMember]
        E_BUSY,
        [EnumMember]
        E_EXTENDED,
        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,
        [EnumMember]
        CH_EXTERNAL,
        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,
        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,
        [EnumMember]
        PR_STANDARD,
        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,
        [EnumMember]
        PS_ONLINE,
        [EnumMember]
        PS_OFF,
        [EnumMember]
        PS_OFFLINE,
        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */
    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    //
    // Specific Enumerations
    //

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string ToneSoundedCount = "ToneSoundedCount";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    public class Melody
    {
        public const int TONE_MT_NONE = 0;
        public const int TONE_MT_TYPE1 = 1;
        public const int TONE_MT_TYPE2 = 2;
        public const int TONE_MT_TYPE3 = 3;
        public const int TONE_MT_TYPE4 = 4;
        public const int TONE_MT_TYPE5 = 5;
    }

    #endregion

    #region Version 1.2

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class ToneIndicatorEvent
    {
        //[DataMember]
        //public DataEvent DataEvent { get; set; }
        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }
        [DataMember]
        public ErrorEvent ErrorEvent { get; set; }
        [DataMember]
        public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class ToneIndicatorEventResponse
    {
        //[DataMember]
        //public DataEventResponse DataEventResponse { get; set; }
        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }
        [DataMember]
        public ErrorEventResponse ErrorEventResponse { get; set; }
        [DataMember]
        public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }
    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int EventNumber { get; set; }
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,
        [EnumMember]
        EL_INPUT_DATA,
        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/ToneIndicator/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,
        [EnumMember]
        ER_CONTINUEINPUT,
        [EnumMember]
        ER_RETRY,
    }

    #endregion
}
